<script>
import CardBasicStyle from '~/components/common/card-basic-style.vue';
import DemoModal from '~/components/common/demo-modal.vue';

export default {
  name: 'SolutionDemo',
  components: { CardBasicStyle, DemoModal },
  props: {
    header: {
      type: String,
      required: true,
    },
    subheader: {
      type: String,
      required: true,
    },
    aiDemo: {
      type: Object,
      required: true,
      default: null,
    },
    ciDemo: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      aiModal: {
        open: false,
      },
      ciModal: {
        open: false,
      },
    };
  },
  methods: {
    openAiModal() {
      this.aiModal.open = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
    openCiModal() {
      this.ciModal.open = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
    closeAiModal() {
      this.aiModal.open = false;
    },
    closeCiModal() {
      this.ciModal.open = false;
    },
  },
};
</script>

<template>
  <section class="cta-card">
    <CardBasicStyle id="demo" no-hover no-header>
      <div class="demo-text">
        <SlpTypography
          class="demo-text-header"
          tag="h3"
          variant="heading4-bold"
        >
          {{ header }}
        </SlpTypography>
        <SlpTypography class="slp-mb-32" tag="div" variant="body1">
          {{ subheader }}
        </SlpTypography>
      </div>
      <div class="demo-videos">
        <div class="ci-demo">
          <div class="video">
            <div
              class="image__container"
              :data-ga-location="ciDemo.launchButton.data_ga_location"
              :data-ga-name="ciDemo.launchButton.data_ga_name"
              @click="openCiModal"
            >
              <img
                class="demo-thumbnail"
                :src="ciDemo.video.thumbnail"
                :alt="ciDemo.video.altText"
              />
              <SlpButton variant="secondary" class="slp-mt-32 demo-button">
                <SlpIcon
                  :name="ciDemo.launchButton.icon_name"
                  :variant="ciDemo.launchButton.icon_variant"
                  alt="laptop-play-video"
                /><SlpTypography variant="demo-button-text body2-bold">{{
                  ciDemo.launchButton.text
                }}</SlpTypography></SlpButton
              >
            </div>
          </div>

          <DemoModal
            v-show="ciModal.open"
            :data="ciDemo"
            :visible="ciModal.open"
            @close="closeCiModal"
          >
          </DemoModal>
        </div>
        <div class="ai-demo">
          <div class="video">
            <div
              class="image__container"
              :data-ga-location="aiDemo.launchButton.data_ga_location"
              :data-ga-name="aiDemo.launchButton.data_ga_name"
              @click="openAiModal"
            >
              <img
                class="demo-thumbnail"
                :src="aiDemo.video.thumbnail"
                :alt="aiDemo.video.altText"
              />
              <SlpButton variant="secondary" class="slp-mt-32 demo-button">
                <SlpIcon
                  :name="aiDemo.launchButton.icon_name"
                  :variant="aiDemo.launchButton.icon_variant"
                  alt="laptop-play-video"
                /><SlpTypography variant=" demo-button-text body2-bold">{{
                  aiDemo.launchButton.text
                }}</SlpTypography></SlpButton
              >
            </div>
          </div>

          <DemoModal
            v-show="aiModal.open"
            :data="aiDemo"
            :visible="aiModal.open"
            @close="closeAiModal"
          >
          </DemoModal>
        </div>
      </div>
    </CardBasicStyle>
  </section>
</template>

<style lang="scss" scoped>
.cta-card {
  margin: $spacing-32 0 160px 0;
}
#demo {
  padding: 48px;
  margin-bottom: 96px;
  display: flex;
  flex-direction: column;
  .demo-text {
    display: flex;
    flex-direction: column;
    justify-content: flex-start;
    flex: 2 1 0;
    &-header {
      margin-bottom: 16px;
    }
  }

  .demo-videos {
    display: flex;
    flex-direction: row;
    gap: 32px;

    @media screen and (max-width: $breakpoint-md) {
      flex-direction: column;
      gap: 24px;
    }
  }
  .video {
    max-width: 690px;
    max-height: 285px;
    display: flex;
    flex: 2 1 0;
    .image__container {
      position: relative;
      border-radius: 4px;
      border: 0.5px solid black;
      overflow: hidden;

      &:hover::before {
        opacity: 1;
      }
    }
    .demo-thumbnail {
      max-width: 100%;
      aspect-ratio: 2 / 1;

      display: block;
      height: auto;
      filter: blur(1px);
      z-index: 1;
      transition: filter 0.3s ease-in-out;
      &:hover {
        z-index: 0;
        cursor: pointer;
        background: linear-gradient(
          to bottom,
          rgba(110, 73, 203, 0.3) rgba(255, 212, 216, 0.45)
        );
      }
    }
  }
  .demo-button {
    position: absolute;
    top: 37%;
    left: 50%;
    transform: translate(-50%, -50%);
    z-index: 2;
    border-radius: 30px;
    &:hover {
      box-shadow: 0 2px 50px rgba($color-surface-700, 0.25);
    }
    &-text {
      width: 175px;
    }
    .slp-icon {
      margin-right: 5px;
      width: 24px;
      height: 24px;
    }
  }
  @media (max-width: $breakpoint-sm) {
    display: flex;
    flex-direction: column;
    padding: $spacing-32;

    .image__container {
      max-width: 100%;
    }
    .video-text {
      padding: 0 0 $spacing-8 0;
    }

    .video {
      width: fit-content;
      display: flex;
      flex-wrap: wrap;
      align-items: center;
    }

    .demo-button {
      position: absolute;
      top: 30%;
      left: 50%;
      font-size: 16px;
      width: 250px;
      transform: translate(-50%, -50%);
      display: flex;
      flex-direction: row;
      align-items: center;
      justify-content: center;
      &-text {
        width: 155px;
      }
    }
  }
}
</style>
